diff -rupN seq24-rev48 adding win32/src/perfedit.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/perfedit.cpp
--- seq24-rev48 adding win32/src/perfedit.cpp	2009-05-20 20:30:46.750000000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/perfedit.cpp	2009-05-20 20:30:55.375000000 -0500
@@ -34,6 +34,13 @@
 
 using namespace sigc;
 
+// tooltip helper, for old vs new gtk...
+#if GTK_MINOR_VERSION >= 12
+#   define add_tooltip( obj, text ) obj->set_tooltip_text( text);
+#else
+#   define add_tooltip( obj, text ) m_tooltips->set_tip( *obj, text );
+#endif
+
 perfedit::perfedit( perform *a_perf ) 
 {
     using namespace Menu_Helpers;
@@ -79,7 +86,7 @@ perfedit::perfedit( perform *a_perf ) 
     m_button_grow = manage( new Button());
     m_button_grow->add( *manage( new Arrow( Gtk::ARROW_RIGHT, Gtk::SHADOW_OUT )));
     m_button_grow->signal_clicked().connect( mem_fun( *this, &perfedit::grow)); 
-    m_tooltips->set_tip( *m_button_grow, "Increase size of Grid." );
+    add_tooltip( m_button_grow, "Increase size of Grid." );
 
 
     /* fill table */
@@ -113,7 +120,7 @@ perfedit::perfedit( perform *a_perf ) 
     m_button_snap = manage( new Button());
     m_button_snap->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( snap_xpm ))));
     m_button_snap->signal_clicked().connect(  bind<Menu *>( mem_fun( *this, &perfedit::popup_menu), m_menu_snap  ));
-    m_tooltips->set_tip( *m_button_snap, "Grid snap. (Fraction of Measure Length)" );
+    add_tooltip( m_button_snap, "Grid snap. (Fraction of Measure Length)" );
     m_entry_snap = manage( new Entry());
     m_entry_snap->set_size_request( 40, -1 );
     m_entry_snap->set_editable( false );
@@ -146,7 +153,7 @@ perfedit::perfedit( perform *a_perf ) 
     m_button_bpm = manage( new Button());
     m_button_bpm->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( down_xpm  ))));
     m_button_bpm->signal_clicked().connect(  bind<Menu *>( mem_fun( *this, &perfedit::popup_menu), m_menu_bpm  ));
-    m_tooltips->set_tip( *m_button_bpm, "Time Signature. Beats per Measure" );
+    add_tooltip( m_button_bpm, "Time Signature. Beats per Measure" );
     m_entry_bpm = manage( new Entry());
     m_entry_bpm->set_width_chars(2);
     m_entry_bpm->set_editable( false );
@@ -156,7 +163,7 @@ perfedit::perfedit( perform *a_perf ) 
     m_button_bw = manage( new Button());
     m_button_bw->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( down_xpm  ))));
     m_button_bw->signal_clicked().connect(  bind<Menu *>( mem_fun( *this, &perfedit::popup_menu), m_menu_bw  ));
-    m_tooltips->set_tip( *m_button_bw, "Time Signature.  Length of Beat" );
+    add_tooltip( m_button_bw, "Time Signature.  Length of Beat" );
     m_entry_bw = manage( new Entry());
     m_entry_bw->set_width_chars(2);
     m_entry_bw->set_editable( false );
@@ -165,43 +172,43 @@ perfedit::perfedit( perform *a_perf ) 
     m_button_undo = manage( new Button());
     m_button_undo->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( undo_xpm  ))));
     m_button_undo->signal_clicked().connect(  mem_fun( *this, &perfedit::undo));
-    m_tooltips->set_tip( *m_button_undo, "Undo." );
+    add_tooltip( m_button_undo, "Undo." );
  
 
     /* expand */
     m_button_expand = manage( new Button());
     m_button_expand->add(*manage( new Image(Gdk::Pixbuf::create_from_xpm_data( expand_xpm ))));
     m_button_expand->signal_clicked().connect(  mem_fun( *this, &perfedit::expand));
-    m_tooltips->set_tip( *m_button_expand, "Expand between L and R markers." );
+    add_tooltip( m_button_expand, "Expand between L and R markers." );
 
     /* collapse */
     m_button_collapse = manage( new Button());
     m_button_collapse->add(*manage( new Image(Gdk::Pixbuf::create_from_xpm_data( collapse_xpm ))));
     m_button_collapse->signal_clicked().connect(  mem_fun( *this, &perfedit::collapse));
-    m_tooltips->set_tip( *m_button_collapse, "Collapse between L and R markers." );
+    add_tooltip( m_button_collapse, "Collapse between L and R markers." );
 
     /* copy */
     m_button_copy = manage( new Button());
     m_button_copy->add(*manage( new Image(Gdk::Pixbuf::create_from_xpm_data( copy_xpm ))));
     m_button_copy->signal_clicked().connect(  mem_fun( *this, &perfedit::copy ));
-    m_tooltips->set_tip( *m_button_copy, "Expand and copy between L and R markers." );
+    add_tooltip( m_button_copy, "Expand and copy between L and R markers." );
 
 
     m_button_loop = manage( new ToggleButton() );
     m_button_loop->add(*manage( new Image(Gdk::Pixbuf::create_from_xpm_data( loop_xpm ))));
     m_button_loop->signal_toggled().connect(  mem_fun( *this, &perfedit::set_looped ));
-    m_tooltips->set_tip( *m_button_loop, "Play looped between L and R." );
+    add_tooltip( m_button_loop, "Play looped between L and R." );
 
 
     m_button_stop = manage( new Button() );
     m_button_stop->add(*manage( new Image(Gdk::Pixbuf::create_from_xpm_data( stop_xpm ))));
     m_button_stop->signal_clicked().connect( mem_fun( *this, &perfedit::stop_playing));
-    m_tooltips->set_tip( *m_button_stop, "Stop playing." );
+    add_tooltip( m_button_stop, "Stop playing." );
 
     m_button_play = manage( new Button() );
     m_button_play->add(*manage( new Image(Gdk::Pixbuf::create_from_xpm_data( play2_xpm ))));
     m_button_play->signal_clicked().connect(  mem_fun( *this, &perfedit::start_playing));
-    m_tooltips->set_tip( *m_button_play, "Begin playing at L marker." );
+    add_tooltip( m_button_play, "Begin playing at L marker." );
 
 
     m_hlbox->pack_end( *m_button_copy , false, false ); 
@@ -253,15 +260,17 @@ perfedit::on_key_press_event(GdkEventKey
     if ( a_ev->type == GDK_KEY_PRESS ){
 
         if ( global_print_keys ){
-            printf( "key_press[%d]\n", a_ev->keyval );
+            printf( "key_press[%d] == %s\n", a_ev->keyval, key2text( a_ev->keyval ) );
         }
-        if ( a_ev->keyval == m_mainperf->m_key_start )
+        // the start/end key may be the same key (i.e. SPACE)
+        // allow toggling when the same key is mapped to both triggers (i.e. SPACEBAR)
+        bool dont_toggle = m_mainperf->m_key_start != m_mainperf->m_key_stop;
+        if ( a_ev->keyval == m_mainperf->m_key_start && (dont_toggle || !m_mainperf->is_running()) )
         {
             start_playing();
             return true;
         }
-
-        if ( a_ev->keyval == m_mainperf->m_key_stop )
+        else if ( a_ev->keyval == m_mainperf->m_key_stop && (dont_toggle || m_mainperf->is_running()) )
         {
             stop_playing();
             return true;
diff -rupN seq24-rev48 adding win32/src/perform.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/perform.cpp
--- seq24-rev48 adding win32/src/perform.cpp	2009-05-20 20:30:46.937500000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/perform.cpp	2009-05-20 20:30:55.578125000 -0500
@@ -40,12 +40,17 @@ perform::perform()
 		
 		
     }
-
+    m_mute_group_selected = 0;
+    m_mode_group = true;
     m_running = false;
     m_looping = false;
     m_inputing = true;
     m_outputing = true;
     m_tick = 0;
+    m_midiclockrunning = false;
+    m_usemidiclock = false;
+    m_midiclocktick = 0;
+    m_midiclockpos = -1;
 
     thread_trigger_width_ms = c_thread_trigger_width_ms;
 
@@ -62,39 +67,72 @@ perform::perform()
 		m_midi_cc_off[i] = zero;
     }
 
-    key_events[ GDK_1 ] = 0; 
-    key_events[ GDK_q ] = 1; 
-    key_events[ GDK_a ] = 2;
-    key_events[ GDK_z ] = 3; 
-    key_events[ GDK_2 ] = 4; 
-    key_events[ GDK_w ] = 5;
-    key_events[ GDK_s ] = 6; 
-    key_events[ GDK_x ] = 7; 
-    key_events[ GDK_3 ] = 8;
-    key_events[ GDK_e ] = 9; 
-    key_events[ GDK_d ] = 10; 
-    key_events[ GDK_c ] = 11;
-    key_events[ GDK_4 ] = 12; 
-    key_events[ GDK_r ] = 13; 
-    key_events[ GDK_f ] = 14;
-    key_events[ GDK_v ] = 15; 
-    key_events[ GDK_5 ] = 16; 
-    key_events[ GDK_t ] = 17;
-    key_events[ GDK_g ] = 18; 
-    key_events[ GDK_b ] = 19; 
-    key_events[ GDK_6 ] = 20;
-    key_events[ GDK_y ] = 21; 
-    key_events[ GDK_h ] = 22; 
-    key_events[ GDK_n ] = 23;
-    key_events[ GDK_7 ] = 24; 
-    key_events[ GDK_u ] = 25; 
-    key_events[ GDK_j ] = 26;
-    key_events[ GDK_m ] = 27; 
-    key_events[ GDK_8 ] = 28; 
-    key_events[ GDK_i ] = 29;
-    key_events[ GDK_k ] = 30; 
-    key_events[ GDK_comma ] = 31;
-
+    m_show_ui_sequence_key = true;
+    
+    set_key_event( GDK_1, 0 );
+    set_key_event( GDK_q, 1 );
+    set_key_event( GDK_a, 2 );
+    set_key_event( GDK_z, 3 );
+    set_key_event( GDK_2, 4 );
+    set_key_event( GDK_w, 5 );
+    set_key_event( GDK_s, 6 );
+    set_key_event( GDK_x, 7 );
+    set_key_event( GDK_3, 8 );
+    set_key_event( GDK_e, 9 );
+    set_key_event( GDK_d, 10 );
+    set_key_event( GDK_c, 11 );
+    set_key_event( GDK_4, 12 );
+    set_key_event( GDK_r, 13 );
+    set_key_event( GDK_f, 14 );
+    set_key_event( GDK_v, 15 );
+    set_key_event( GDK_5, 16 );
+    set_key_event( GDK_t, 17 );
+    set_key_event( GDK_g, 18 );
+    set_key_event( GDK_b, 19 );
+    set_key_event( GDK_6, 20 );
+    set_key_event( GDK_y, 21 );
+    set_key_event( GDK_h, 22 );
+    set_key_event( GDK_n, 23 );
+    set_key_event( GDK_7, 24 );
+    set_key_event( GDK_u, 25 );
+    set_key_event( GDK_j, 26 );
+    set_key_event( GDK_m, 27 );
+    set_key_event( GDK_8, 28 );
+    set_key_event( GDK_i, 29 );
+    set_key_event( GDK_k, 30 );
+    set_key_event( GDK_comma, 31 );
+    set_key_group( 33, 0 );
+    set_key_group( 34, 1 );
+    set_key_group( 163, 2 );
+    set_key_group( 36, 3 );
+    set_key_group( 37, 4 );
+    set_key_group( 38, 5 );
+    set_key_group( 47, 6 );
+    set_key_group( 40, 7 );
+    set_key_group( 81, 8 );
+    set_key_group( 87, 9 );
+    set_key_group( 69, 10 );
+    set_key_group( 82, 11 );
+    set_key_group( 84, 12 );
+    set_key_group( 89, 13 );
+    set_key_group( 85, 14 );
+    set_key_group( 73, 15 );
+    set_key_group( 65, 16 );
+    set_key_group( 83, 17 );
+    set_key_group( 68, 18 );
+    set_key_group( 70, 19 );
+    set_key_group( 71, 20 );
+    set_key_group( 72, 21 );
+    set_key_group( 74, 22 );
+    set_key_group( 75, 23 );
+    set_key_group( 90, 24 );
+    set_key_group( 88, 25 );
+    set_key_group( 67, 26 );
+    set_key_group( 86, 27 );
+    set_key_group( 66, 28 );
+    set_key_group( 78, 29 );
+    set_key_group( 77, 30 );
+    set_key_group( 59, 31 );
     
     m_key_bpm_up = GDK_apostrophe;
     m_key_bpm_dn = GDK_semicolon;
@@ -103,9 +141,14 @@ perform::perform()
     m_key_queue = GDK_Control_R;
     m_key_snapshot_1 = GDK_Alt_L;
     m_key_snapshot_2 = GDK_Alt_R;
+    m_key_keep_queue = 92;
     
     m_key_screenset_up = GDK_bracketright;
     m_key_screenset_dn = GDK_bracketleft;
+    m_key_set_playing_screenset = 65360;
+    m_key_group_on = 236;
+    m_key_group_off = 39;
+    m_key_group_learn = GDK_Insert;
 
     m_key_start  = GDK_space;
     m_key_stop   = GDK_Escape;
@@ -170,8 +213,7 @@ perform::init_jack( void )
                 m_jack_master = false;
              
             }
-            
-            if (jack_activate(m_jack_client)) {
+             if (jack_activate(m_jack_client)) {
                 printf("Cannot register as JACK client\n");
                 m_jack_running = false;
                 break;
@@ -240,8 +282,123 @@ perform::clear_all( void )
     }
 
 }
+void
+perform::set_mode_group_mute ()
+{
+    m_mode_group = true;
+    return;
+}
 
+void
+perform::unset_mode_group_mute ()
+{
+    m_mode_group = false;
+    return;
+}
+
+void
+perform::set_group_mute_state (int a_g_track, bool a_mute_state)
+{
+    if (a_g_track < 0)
+        a_g_track = 0;
+    if (a_g_track > c_seqs_in_set)
+        a_g_track = c_seqs_in_set -1;
+    m_mute_group[a_g_track + m_mute_group_selected * c_seqs_in_set] = a_mute_state;
+    return;
+}
 
+bool
+perform::get_group_mute_state (int a_g_track)
+{
+    if (a_g_track < 0)
+        a_g_track = 0;
+    if (a_g_track > c_seqs_in_set)
+        a_g_track = c_seqs_in_set -1;
+    return m_mute_group[a_g_track + m_mute_group_selected * c_seqs_in_set];
+}
+
+void
+perform::select_group_mute (int a_g_mute)
+{
+    int j = (a_g_mute * c_seqs_in_set);
+    int k = m_playing_screen * c_seqs_in_set;
+    if (a_g_mute < 0)
+        a_g_mute = 0;
+    if (a_g_mute > c_seqs_in_set)
+        a_g_mute = c_seqs_in_set -1;
+    if (m_mode_group_learn)
+        for (int i = 0; i < c_seqs_in_set; i++) {
+            if (is_active(i + k)) {
+                assert(m_seqs[i + k]);
+                m_mute_group[i + j] = m_seqs[i + k]->get_playing();
+            }
+        }
+    m_mute_group_selected = a_g_mute;
+    return;
+}
+void perform::set_mode_group_learn (void)
+{
+    set_mode_group_mute();
+    m_mode_group_learn = true;
+    for (int x = 0; x < m_notify.size(); ++x)
+        m_notify[x]->on_grouplearnchange( true );
+    return;
+}
+
+void perform::unset_mode_group_learn (void)
+{
+    for (int x = 0; x < m_notify.size(); ++x)
+        m_notify[x]->on_grouplearnchange( false );
+    m_mode_group_learn = false;
+    return;
+}
+
+void
+perform::select_mute_group ( int a_group )
+{
+    int j = (a_group * c_seqs_in_set);
+    int k = m_playing_screen * c_seqs_in_set;
+    if (a_group < 0)
+        a_group = 0;
+    if (a_group > c_seqs_in_set)
+        a_group = c_seqs_in_set -1;
+    m_mute_group_selected = a_group;
+    for (int i = 0; i < c_seqs_in_set; i++) {
+        if ((m_mode_group_learn) && (is_active(i + k))) {
+            assert(m_seqs[i + k]);
+            m_mute_group[i + j] = m_seqs[i + k]->get_playing();
+        }
+        m_tracks_mute_state[i] = m_mute_group[i + m_mute_group_selected * c_seqs_in_set];
+    }
+    return;
+}
+
+void
+perform::mute_group_tracks (void)
+{
+    if (m_mode_group) {
+        for (int i=0; i< c_seqs_in_set; i++) {
+            for (int j=0; j < c_seqs_in_set; j++) {
+                if ( is_active(i * c_seqs_in_set + j) ) {
+                    if ((i == m_playing_screen) && (m_tracks_mute_state[j])) {
+                            sequence_playing_on (i * c_seqs_in_set + j);
+                    } else {
+                        sequence_playing_off (i * c_seqs_in_set + j);
+                    }
+                }
+            }
+               
+        }
+    }
+}
+
+void
+perform::select_and_mute_group (int a_g_group)
+{
+    select_mute_group(a_g_group);
+    mute_group_tracks();
+    return;
+}
 
 void
 perform::mute_all_tracks( void )
@@ -624,6 +781,26 @@ perform::get_screenset( void )
 {
     return m_screen_set;
 }
+ void
+ perform::set_playing_screenset (void)
+ {
+    for (int j, i = 0; i < c_seqs_in_set; i++) {
+        j = i + m_playing_screen * c_seqs_in_set;
+        if ( is_active(j) ){
+            assert( m_seqs[j] );
+            m_tracks_mute_state[i] = m_seqs[j]->get_playing();
+        }
+    }
+    m_playing_screen = m_screen_set;
+    mute_group_tracks();
+ }
+
+ int
+ perform::get_playing_screenset (void)
+ {
+    return m_playing_screen;
+ }
+
 
 void 
 perform::set_offset( int a_offset ) 
@@ -893,6 +1070,8 @@ perform::inner_stop( )
     set_running( false );
     //off_sequences();
     reset_sequences(  );
+    
+    m_usemidiclock = false;
 }
 
 
@@ -912,6 +1091,20 @@ perform::off_sequences( void )
 
 
 
+void 
+perform::all_notes_off( void )
+{
+    for (int i=0; i< c_max_sequence; i++ ){
+		
+		if ( is_active(i) == true ){
+			assert( m_seqs[i] );
+
+			m_seqs[i]->off_playing_notes( );
+		} 
+    }
+    /* flush the bus */
+    m_master_bus.flush();
+}
 
 void 
 perform::reset_sequences( void )
@@ -921,7 +1114,7 @@ perform::reset_sequences( void )
 		if ( is_active(i) == true ){
 			assert( m_seqs[i] );
 
-                        bool state = m_seqs[i]->get_playing();
+			bool state = m_seqs[i]->get_playing();
                         
 			m_seqs[i]->off_playing_notes( );
 			m_seqs[i]->set_playing( false );
@@ -1249,7 +1442,21 @@ perform::output_func(void)
             /* get delta ticks, delta_ticks_f is in 1000th of a tick */
             double delta_tick   =  (double) (bpm * ppqn * (delta_us/60000000.0f) ); 
 
-            //printf ( "delta_tick[%ld.%03ld]\n", delta_tick, delta_tick_f  );
+            if ( m_usemidiclock)
+            {
+               delta_tick = m_midiclocktick;
+               m_midiclocktick = 0;
+            }
+            if ( 0 <= m_midiclockpos)
+            {
+                delta_tick = 0;
+                clock_tick     = m_midiclockpos;
+                current_tick   = m_midiclockpos;
+                total_tick     = m_midiclockpos;
+                m_midiclockpos = -1;
+                //init_clock = true;
+            }
+
             //printf ( "    delta_tick[%lf]\n", delta_tick  );
 #ifdef JACK_SUPPORT
 
@@ -1716,9 +1923,40 @@ perform::handle_midi_control( int a_cont
                 set_sequence_control_status( c_status_queue );
             else
                 unset_sequence_control_status( c_status_queue );
+        //andy cases
+        case c_midi_control_mod_gmute:
+
+            printf ( "gmute\n" );
+           
+            if (a_state)
+                set_mode_group_mute();
+            else
+                unset_mode_group_mute();
             break;
-            
-        default:
+           
+        case c_midi_control_mod_glearn:
+
+            //printf ( "glearn\n" );
+
+            if (a_state)
+                set_mode_group_learn();
+            else
+                unset_mode_group_learn();
+            break;
+           
+        case c_midi_control_play_ss:
+
+            //printf ( "play_ss\n" );
+
+            set_playing_screenset();
+            break;
+           
+         default:
+            if ((a_control >= c_seqs_in_set) && (a_control < c_midi_track_ctrl)) {
+                //printf ( "group mute\n" );
+           
+                select_and_mute_group(a_control - c_seqs_in_set);
+            }
             break;
             
     }
@@ -1738,6 +1976,45 @@ perform::input_func( void ){
                 
                 if ( m_master_bus.get_midi_event( &ev ) ){
                     
+                    // Obey MidiTimeClock:
+                    if (ev.get_status() == EVENT_MIDI_START)
+                    {
+                         stop();
+                         start( false );
+                         m_midiclockrunning = true;
+                         m_usemidiclock = true;
+                         m_midiclocktick = 0;
+                         m_midiclockpos = 0;
+                    }
+                    // midi continue: start from current pos.
+                    else if (ev.get_status() == EVENT_MIDI_CONTINUE)
+                    {
+                         m_midiclockrunning = true;
+                         start( false );
+                         //m_usemidiclock = true;
+                    }
+                    else if (ev.get_status() == EVENT_MIDI_STOP)
+                    {
+                         // do nothing, just let the system pause
+                         // since we're not getting ticks after the stop, the song wont advance
+                         // when start is recieved, we'll reset the position, or
+                         // when continue is recieved, we wont
+                         m_midiclockrunning = false;
+                         all_notes_off();
+                    }
+                    else if (ev.get_status() == EVENT_MIDI_CLOCK)
+                    {
+                         if (m_midiclockrunning)
+                            m_midiclocktick += 8;
+                    }
+                    // not tested (todo: test it!)
+                    else if (ev.get_status() == EVENT_MIDI_SONG_POS)
+                    {
+                         unsigned char a, b;
+                         ev.get_data( &a, &b );
+                         m_midiclockpos = ((int)a << 7) && (int)b;
+                    }
+                    
                     /* filter system wide messages */
                     if ( ev.get_status() <= EVENT_SYSEX ){  
                         
@@ -1923,8 +2200,21 @@ void
 perform::sequence_playing_on( int a_sequence )
 {
     if ( is_active(a_sequence) == true ){
+        if (m_mode_group && (m_playing_screen == m_screen_set)
+          && (a_sequence >= (m_playing_screen * c_seqs_in_set))
+          && (a_sequence < ((m_playing_screen + 1) * c_seqs_in_set)))
+            m_tracks_mute_state[a_sequence - m_playing_screen * c_seqs_in_set] = true;
 		assert( m_seqs[a_sequence] );
-		m_seqs[a_sequence]->set_playing(true);
+        if (!(m_seqs[a_sequence]->get_playing())) {
+            if (m_control_status & c_status_queue ) {
+                if (!(m_seqs[a_sequence]->get_queued()))
+                    m_seqs[a_sequence]->toggle_queued();
+            } else
+                m_seqs[a_sequence]->set_playing(true);
+        } else {
+            if ((m_seqs[a_sequence]->get_queued()) && (m_control_status & c_status_queue ))
+                m_seqs[a_sequence]->toggle_queued();
+        }
     } 
 }
 
@@ -1933,11 +2223,76 @@ void
 perform::sequence_playing_off( int a_sequence )
 {
     if ( is_active(a_sequence) == true ){
-		assert( m_seqs[a_sequence] );
-		m_seqs[a_sequence]->set_playing(false);
+        if (m_mode_group && (m_playing_screen == m_screen_set)
+          && (a_sequence >= (m_playing_screen * c_seqs_in_set))
+          && (a_sequence < ((m_playing_screen + 1) * c_seqs_in_set)))
+            m_tracks_mute_state[a_sequence - m_playing_screen * c_seqs_in_set] = false;
+        assert( m_seqs[a_sequence] );
+        if (m_seqs[a_sequence]->get_playing()) {
+            if (m_control_status & c_status_queue ) {
+                if (!(m_seqs[a_sequence]->get_queued()))
+                    m_seqs[a_sequence]->toggle_queued();
+            } else
+                m_seqs[a_sequence]->set_playing(false);
+        } else {
+            if ((m_seqs[a_sequence]->get_queued()) && (m_control_status & c_status_queue ))
+                m_seqs[a_sequence]->toggle_queued();
+        }
     } 
 }
 
+void
+perform::set_key_event( unsigned int keycode, long sequence_slot )
+{
+     // unhook previous binding...
+     std::map<unsigned int,long>::iterator it1 = key_events.find( keycode );
+     if (it1 != key_events.end())
+     {
+         std::map<long,unsigned int>::iterator i = key_events_rev.find( it1->second );
+         if (i != key_events_rev.end())
+             key_events_rev.erase( i );
+         key_events.erase( it1 );
+     }
+     std::map<long,unsigned int>::iterator it2 = key_events_rev.find( sequence_slot );
+     if (it2 != key_events_rev.end())
+     {
+         std::map<unsigned int,long>::iterator i = key_events.find( it2->second );
+         if (i != key_events.end())
+             key_events.erase( i );
+         key_events_rev.erase( it2 );
+     }
+     // set
+     key_events[keycode] = sequence_slot;
+     key_events_rev[sequence_slot] = keycode;
+}
+
+void
+perform::set_key_group( unsigned int keycode, long group_slot )
+{
+     // unhook previous binding...
+     std::map<unsigned int,long>::iterator it1 = key_groups.find( keycode );
+     if (it1 != key_groups.end())
+     {
+         std::map<long,unsigned int>::iterator i = key_groups_rev.find( it1->second );
+         if (i != key_groups_rev.end())
+             key_groups_rev.erase( i );
+         key_groups.erase( it1 );
+     }
+     std::map<long,unsigned int>::iterator it2 = key_groups_rev.find( group_slot );
+     if (it2 != key_groups_rev.end())
+     {
+         std::map<unsigned int,long>::iterator i = key_groups.find( it2->second );
+         if (i != key_groups.end())
+             key_groups.erase( i );
+         key_groups_rev.erase( it2 );
+     }
+     // set
+     key_groups[keycode] = group_slot;
+     key_groups_rev[group_slot] = keycode;
+}
+
+
+
 #ifdef JACK_SUPPORT
 void jack_timebase_callback(jack_transport_state_t state, jack_nframes_t nframes, 
 	      jack_position_t *pos, int new_pos, void *arg)
diff -rupN seq24-rev48 adding win32/src/perform.h seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/perform.h
--- seq24-rev48 adding win32/src/perform.h	2009-05-20 20:30:46.968750000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/perform.h	2009-05-20 20:30:55.609375000 -0500
@@ -59,18 +59,39 @@ const int c_status_replace  = 0x01;
 const int c_status_snapshot = 0x02;
 const int c_status_queue    = 0x04;
 
-const int c_midi_control_bpm_up       = c_seqs_in_set ;
-const int c_midi_control_bpm_dn       = c_seqs_in_set + 1;
-const int c_midi_control_ss_up        = c_seqs_in_set + 2;
-const int c_midi_control_ss_dn        = c_seqs_in_set + 3;
-const int c_midi_control_mod_replace  = c_seqs_in_set + 4;
-const int c_midi_control_mod_snapshot = c_seqs_in_set + 5;
-const int c_midi_control_mod_queue    = c_seqs_in_set + 6;
-const int c_midi_controls             = c_seqs_in_set + 7;
+	 const int c_midi_track_ctrl = c_seqs_in_set * 2;
+	 const int c_midi_control_bpm_up       = c_midi_track_ctrl ;
+	 const int c_midi_control_bpm_dn       = c_midi_track_ctrl + 1;
+	 const int c_midi_control_ss_up        = c_midi_track_ctrl + 2;
+	 const int c_midi_control_ss_dn        = c_midi_track_ctrl + 3;
+	 const int c_midi_control_mod_replace  = c_midi_track_ctrl + 4;
+	 const int c_midi_control_mod_snapshot = c_midi_track_ctrl + 5;
+	 const int c_midi_control_mod_queue    = c_midi_track_ctrl + 6;
+	 //andy midi_control_mod_mute_group
+	 const int c_midi_control_mod_gmute    = c_midi_track_ctrl + 7;
+	 //andy learn_mute_toggle_mode
+	 const int c_midi_control_mod_glearn   = c_midi_track_ctrl + 8;
+	 //andy play only this screen set
+	 const int c_midi_control_play_ss      = c_midi_track_ctrl + 9;
+	 const int c_midi_controls             = c_midi_track_ctrl + 10;//7
+
+struct performcallback
+{
+    virtual void on_grouplearnchange(bool state) {}
+};
 
 class perform
 {
  private:
+    //andy mute group
+    bool m_mute_group[c_gmute_tracks];
+    bool m_tracks_mute_state[c_seqs_in_set];
+    bool m_mode_group;
+    bool m_mode_group_learn;
+    int m_mute_group_selected;
+    //andy playing screen
+    int m_playing_screen;
+   
 
     /* vector of sequences */
     sequence *m_seqs[c_max_sequence];
@@ -107,9 +128,15 @@ class perform
     long m_starting_tick;
     
     long m_tick;
+    bool m_usemidiclock;
+    bool m_midiclockrunning; // stopped or started
+    int  m_midiclocktick;
+    int  m_midiclockpos;
+    
+    bool m_show_ui_sequence_key;
+
    
     void set_running( bool a_running );
-    bool is_running();
 
     void set_playback_mode( bool a_playback_mode );
 
@@ -125,7 +152,12 @@ class perform
 
     condition_var m_condition_var;
 
-    std::map<long,long> key_events;
+    // do not access these directly, use set/lookup below
+    std::map<unsigned int,long> key_events;
+    std::map<unsigned int,long> key_groups;
+    std::map<long,unsigned int> key_events_rev; // reverse lookup, keep this in sync!!
+    std::map<long,unsigned int> key_groups_rev; // reverse lookup, keep this in sync!!
+
 
 #ifdef JACK_SUPPORT
     
@@ -146,21 +178,34 @@ class perform
     void inner_stop();
 
  public:
+    bool is_running();
+    bool is_learn_mode() const { return m_mode_group_learn; }
+
+    // can register here for events...
+    std::vector<performcallback*> m_notify;
 
     unsigned int m_key_bpm_up;
     unsigned int m_key_bpm_dn;
 
     unsigned int m_key_replace;
     unsigned int m_key_queue;
+    unsigned int m_key_keep_queue;
     unsigned int m_key_snapshot_1;
     unsigned int m_key_snapshot_2;
 
     unsigned int m_key_screenset_up;
     unsigned int m_key_screenset_dn;
+    unsigned int m_key_set_playing_screenset;
+   
+    unsigned int m_key_group_on;
+    unsigned int m_key_group_off;
+    unsigned int m_key_group_learn;
+   
 
-    unsigned int m_key_start; 
+    unsigned int m_key_start;
     unsigned int m_key_stop;
 
+    bool show_ui_sequence_key() const { return m_show_ui_sequence_key; }
 
     perform();
     ~perform();
@@ -211,7 +256,17 @@ class perform
 
     void set_screenset( int a_ss );
     int get_screenset( void );
-    
+    void set_playing_screenset( void );
+    int get_playing_screenset( void );
+    void mute_group_tracks (void);
+    void select_and_mute_group (int a_g_group);
+    void set_mode_group_mute ();
+    void select_group_mute (int a_g_mute);
+    void set_mode_group_learn (void);
+    void unset_mode_group_learn (void);
+    bool is_group_learning( void ) { return m_mode_group_learn; }
+    void select_mute_group ( int a_group );
+    void unset_mode_group_mute ();    
     void start( bool a_state );
     void stop();
 
@@ -220,6 +275,7 @@ class perform
     void position_jack( bool a_state );
 
     void off_sequences( void );
+    void all_notes_off( void );
 
     void set_active(int a_sequence, bool a_active);
     void set_was_active( int a_sequence );
@@ -250,6 +306,8 @@ class perform
     void sequence_playing_toggle( int a_sequence );
     void sequence_playing_on( int a_sequence );
     void sequence_playing_off( int a_sequence );
+    void set_group_mute_state (int a_g_track, bool a_mute_state);
+    bool get_group_mute_state (int a_g_track);
     
     void mute_all_tracks( void );
 
@@ -266,11 +324,24 @@ class perform
     void restore_playing_state( void );
     
     
-    std::map<long,long> *get_key_events( void ){ return &key_events; };
+    const std::map<unsigned int,long> *get_key_events( void ) const { return &key_events; };
+    const std::map<unsigned int,long> *get_key_groups( void ) const { return &key_groups; };
+    
+    void set_key_event( unsigned int keycode, long sequence_slot );
+    void set_key_group( unsigned int keycode, long group_slot );
+
+    // getters of keyboard mapping for sequence and groups,
+    // if not found, returns something "safe" (so use get_key()->count() to see if it's there first)
+    unsigned int lookup_keyevent_key( long seqnum ) { if (key_events_rev.count( seqnum )) return key_events_rev[seqnum]; else return '?';}
+    long lookup_keyevent_seq( unsigned int keycode ) { if (key_events.count( keycode )) return key_events[keycode]; else return 0; }
+    unsigned int lookup_keygroup_key( long groupnum ) { if (key_groups_rev.count( groupnum )) return key_groups_rev[groupnum]; else return '?'; }
+    long lookup_keygroup_group( unsigned int keycode ) { if (key_groups.count( keycode )) return key_groups[keycode]; else return 0; }
+
 
 
     friend class midifile;
     friend class optionsfile;
+    friend class options;
 
 #ifdef JACK_SUPPORT
 
@@ -280,7 +351,6 @@ class perform
     friend void jack_timebase_callback(jack_transport_state_t state, jack_nframes_t nframes, 
                                        jack_position_t *pos, int new_pos, void *arg);
 #endif
-
 };
 
 /* located in perform.C */
